#include "mcc_generated_files/mcc.h"

#define TIME_OFF -1     //^C}[gpȂꍇ
#define TIME_UP 0       //^CAbv
#define TIME_ADC_WAIT 10
#define DUTY_MAX 448
/* ϐ錾*/
int16_t timAdc;
uint16_t dutyValue;
/* vg^Cv錾*/
void AdcItr(void);
void mainApp(void);
void mainTimer(void);
void IntTmr4(void);
/* Main application */
void main(void)
{
    SYSTEM_Initialize();
    TMR0_SetInterruptHandler(mainTimer);
    TMR4_SetInterruptHandler(IntTmr4);
    ADC_SetInterruptHandler(AdcItr); //荞ݎAdcIrt֐R[obN
    INTERRUPT_GlobalInterruptEnable();
    INTERRUPT_PeripheralInterruptEnable();

    ADC_SelectChannel(channel_AN0);
    ADC_StartConversion();
    timAdc = TIME_ADC_WAIT;

    while (1)
    {
        mainApp();
    }
}
/* C */
void mainApp(void){
    
    if( timAdc == TIME_UP){
        timAdc = TIME_ADC_WAIT;
        ADC_SelectChannel(channel_AN0); //AN0I
        ADC_StartConversion(); //ADϊJn
    } 
}
/* ^C}Ǘ֐iR[obN֐j */
void mainTimer(void){
    
    if( timAdc > TIME_UP ){
        --timAdc;
    }
}
void IntTmr4(void){
    uint16_t value;
    
    value = dutyValue >> 1;
    //PWM̃f[eB[100%ł500ƂȂ邽
    //CCPR Valueɕϊ
    if( value > DUTY_MAX){
        value = DUTY_MAX;
    }
    value = value >> 2; //8rbglɊZ
    CCPR1L = (uint8_t)value;
}
/* ADϊ荞ݏ */
void AdcItr(void){

    dutyValue = ADC_GetConversionResult(); //ADϊli[
}
/* End of File */